
# EMP-SSL:


## Preparing Training Data
Cifar10 and Cifar100 can be downloaded automatically in the script. ImageNet100 is a special subset of ImageNet. Details can be found in this [link](https://github.com/HobbitLong/CMC/issues/21).

## Getting Started
Current code implementation supports Cifar10, Cifar100 and ImageNet100.

To get started with the EMP-SSL implementation, follow these instructions:

### 1. Install required packages
```
pip install -r requirements.txt
```
### 2. Training

For CIFAR10 or CIFAR100

#### 2.1 EMP-SSL
```
python main_EMP.py --data cifar10 --epoch 2 --patch_sim 200 --arch 'resnet18-cifar' --num_patches 20 --lr 0.3 --bs 100 --msg "EMP"
```

#### 2.2 EMP-MINE
```
python main_MINE.py --data cifar10 --epoch 2 --patch_sim 1 --arch 'resnet18-cifar' --num_patches 20 --lr 0.3 --bs 100 --msg "MINE"
```

#### 2.3 EMP-InfoNCE
```
python main_infoNCE.py --data cifar10 --epoch 2 --patch_sim 1 --arch 'resnet18-cifar' --num_patches 20 --lr 0.3 --bs 100 --msg "infoNCE"
```

#### 2.4 EMP-MILE
```
python main_MILE.py --data cifar10 --epoch 2 --patch_sim 1 --arch 'resnet18-cifar' --num_patches 20 --lr 0.3 --bs 100 --msg "MILE"
```



### 3. Evaluating
Because our model is trained with only fixed size image patches. To evaluate the performance, we adopt bag-of-features model from intra-instance VICReg paper. Change test_patches here to adjust number of patches used in bag-of-feature model for different GPUs.
```
python evaluate.py --model_path 'path to your evaluated model' --test_patches 20 --knn
```

## Acknowledgment
This repo is inspired by [EMP-SSL](https://github.com/tsb0601/EMP-SSL/tree/main),[MCR2](https://github.com/Ma-Lab-Berkeley/MCR2), [solo-learn](https://github.com/vturrisi/solo-learn) and [NMCE](https://github.com/zengyi-li/NMCE-release) repo.

